include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
include linked.inc
includelib linked.lib

debug macro args:vararg
	pushad
	%print args
	popad
endm

.code
start:
	push 4
	push 16
	call LARRAY_create
	mov esi, eax
	
	mov edi, 1
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call LARRAY_insert
	mov [eax], edi
	add edi, 1
	counter_end
	debug "LARRAY add: "
	debug <ustr$(eax)>, 10
	
	mov edi, 1
	counter_begin 100000, HIGH_PRIORITY_CLASS
	push edi
	push esi
	call LARRAY_remove
	add edi, 5
	counter_end
	debug "LARRAY remove: "
	debug <ustr$(eax)>, 10
	
	push esi
	call LARRAY_destroy
	
	exit
	
end start